<?php

namespace InSegment\WorkersFramework\Providers;

use Shavshukov\EventAppBase\Service\Provider;
use Shavshukov\EventAppBase\Service\Container;
use React\Promise;
use InSegment\WorkersFramework\Services\WorkerGc;

class LockfileServiceProvider extends Provider
{

    /**
     * {@inheritDoc}
     */
    public function register(Container $container, ...$registerArguments)
    {
        $container->bind('lockfile-writable-stream', function () {
            return $this->openStream();
        }, true);
    }

    /**
     * Invoke connectors to establish connections
     * 
     * @return \React\Promise\PromiseInterface<\InSegment\WorkersFramework\Services\WorkerGc>
     */
    protected function openStream(): \React\Promise\PromiseInterface
    {
        return Promise\resolve(new WorkerGc($this->app));
    }
}
